// SequenceView.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "fsplugin.h"
#include "cunicode.h"
#include "shlwapi.h"
#include "resource.h"

#define pluginrootlen 1

HANDLE hinst;
char inifilename[MAX_PATH]="fsplugin.ini";  // Unused in this plugin, may be used to save data
BOOL UseSequenceView=true;

char* strlcpy(char* p,char*p2,int maxlen)
{
	if ((int)strlen(p2)>=maxlen) {
		strncpy(p,p2,maxlen);
		p[maxlen]=0;
	} else
		strcpy(p,p2);
	return p;
}

void messageloop()
{
    MSG msg;
	HWND activewin=GetActiveWindow();
    while (PeekMessage(&msg,0,0,0,PM_REMOVE)) {
                if ((activewin==0) || !IsDialogMessage(activewin,&msg)) {
                        TranslateMessage(&msg);
                        DispatchMessage(&msg);
                }
        }
}

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		hinst=hModule;
		break;
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}

int PluginNumber;
tProgressProc ProgressProc=NULL;
tLogProc LogProc=NULL;
tRequestProc RequestProc=NULL;
tProgressProcW ProgressProcW=NULL;
tLogProcW LogProcW=NULL;
tRequestProcW RequestProcW=NULL;

int __stdcall FsInit(int PluginNr,tProgressProc pProgressProc,tLogProc pLogProc,tRequestProc pRequestProc)
{
	ProgressProc=pProgressProc;
    LogProc=pLogProc;
    RequestProc=pRequestProc;
	PluginNumber=PluginNr;
	return 0;
}

int __stdcall FsInitW(int PluginNr,tProgressProcW pProgressProcW,tLogProcW pLogProcW,tRequestProcW pRequestProcW)
{
	ProgressProcW=pProgressProcW;
    LogProcW=pLogProcW;
    RequestProcW=pRequestProcW;
	PluginNumber=PluginNr;
	return 0;
}

typedef struct {
	WCHAR PathW[wdirtypemax];
	WCHAR LastFoundNameW[wdirtypemax];
	LPWIN32_FIND_DATAW* resultlist;
	int index,count;
	BOOL searchroot;

} tLastFindStuct,*pLastFindStuct;

int getSequenceNumber(WCHAR *wname) {
	int ret=0;
	while (wname[0]>='0' && wname[0]<='9') {
		ret=ret*10+(wname[0]-'0');
		wname++;
	}
	if (wname[0]==0 || wname[0]=='.')
		return ret;
	else
		return -1;
}

#define COUNTOF(x) sizeof(x)/sizeof(x[0])

void buildNewName(WCHAR* wlastnrstart,int maxlen,int lastnr) {
	WCHAR* wrest=wlastnrstart;	
	WCHAR numbuf[32];
	WCHAR extbuf[255];
	while (wrest[0]>='0' && wrest[0]<='9')
		wrest++;
	if (wrest[0]=='.')
		wcslcpy(extbuf,wrest,COUNTOF(extbuf)-1);
	else
		extbuf[0]=0;
	_itow(lastnr,numbuf,10);
	memmove(wlastnrstart+1,wlastnrstart,2*wcslen(wlastnrstart)+2);
	wlastnrstart[0]='<';
	wrest++;
	wrest[0]=0;
	wcslcat(wlastnrstart,L"-",maxlen);
	wcslcat(wlastnrstart,numbuf,maxlen);
	wcslcat(wlastnrstart,L">",maxlen);
	wcslcat(wlastnrstart,extbuf,maxlen);
}
	
int ReadWholeDirectoryW(WCHAR* Path,LPWIN32_FIND_DATAW** resultlistret) {
	WCHAR buf[wdirtypemax];
	WIN32_FIND_DATAW FindData;
	wcslcpy(buf,Path,countof(buf)-5);
	wcslcat(buf,L"\\*.*",countof(buf)-1);
	HANDLE searchhandle=FindFirstFileT(buf,&FindData);
	if (searchhandle==INVALID_HANDLE_VALUE)
		return 0;
	int structsize=1024;
	int count=0;
	int firstsorted=0;
	LPWIN32_FIND_DATAW *resultlist=(LPWIN32_FIND_DATAW*)malloc(structsize*sizeof(LPWIN32_FIND_DATAW));
	do {
		WCHAR* pname=FindData.cFileName;
		if (!(pname[0]=='.' && (pname[1]==0 || (pname[1]=='.' && pname[2]==0)))) {
			if (count+1>=structsize) {
				int oldstructsize=structsize;
				structsize+=1024;
				LPWIN32_FIND_DATAW* resultlist2=(LPWIN32_FIND_DATAW*)malloc(structsize*sizeof(LPWIN32_FIND_DATAW));
				memcpy(resultlist2,resultlist,oldstructsize*sizeof(LPWIN32_FIND_DATAW));
				free(resultlist);
				resultlist=resultlist2;
			}
			// now do insertion sort!
			BOOL newDir=(FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)!=0;
			int I=0;
			if (newDir) {   // all dirs to the beginning, order doesn't matter
				firstsorted++;
			} else {
				WCHAR* newExt=wcsrchr(FindData.cFileName,'.');
				if (newExt==NULL)
					newExt=FindData.cFileName+wcslen(FindData.cFileName);
				BOOL sortFirst=false;
				if (newExt>FindData.cFileName) {
					newExt--;
					if (newExt[0]<'0' || newExt[0]>'9') {
						sortFirst=true;
						firstsorted++;
					}
					newExt++;
				}
				if (!sortFirst) {
					int L=firstsorted;  // skips all dirs!
					int H=count-1;
					while (L <= H) {
						int I = (L + H)/2;
						WCHAR* oldExt=wcsrchr(resultlist[I]->cFileName,'.');
						if (oldExt==NULL)
							oldExt=L"";
						int cmp1=wcsicmp(oldExt,newExt);
						if (cmp1==0)
							cmp1=StrCmpLogicalW(resultlist[I]->cFileName,FindData.cFileName);
						if (cmp1<0)
							L=I+1;
						else
							H=I-1;
					}
					I=L;
				}
			}
			if (I<count)
				memmove(&resultlist[I+1],&resultlist[I],(count-I)*sizeof(LPWIN32_FIND_DATAW));
			resultlist[I]=(WIN32_FIND_DATAW*)malloc(sizeof(WIN32_FIND_DATAW));
			memcpy(resultlist[I],&FindData,sizeof(FindData));
			count++;
		}
	} while(FindNextFileT(searchhandle,&FindData));
	FindClose(searchhandle);
	// now combine counted files
	if (count-firstsorted>1 && UseSequenceView) {
		int wlasnrmax=-1;
		int index=firstsorted;
		WCHAR* wlastname=resultlist[index]->cFileName;
		WCHAR* wlastnrstart=NULL;
		int firstofsequence=-1;
		int lastnr=-1;
		while (index<count-1) {
			index++;  // start at comparing 0 and 1
			WCHAR* wname=resultlist[index]->cFileName;
			int i=0;
			while (wname[i] && wname[i]==wlastname[i])
				i++;
			// i now points to the first differing digit, if any
			BOOL hasDigits=false;
			if (wname[i]>='0' && wname[i]<='9') {
				hasDigits=true;
				while (i>0) {
					if (wname[i-1]>='0' && wname[i-1]<='9')
						i--;
					else
						break;			
				}
			}
			// check if sequence numbers!
			int nr=getSequenceNumber(wname+i);
			if (nr>=0 && lastnr==-1)
				lastnr=getSequenceNumber(wlastname+i);
			if (nr>=0 && nr==lastnr+1) {
				if (firstofsequence==-1) {
					wlastnrstart=wlastname+i;
					wlasnrmax=255-i;
					firstofsequence=index-1;
				}
				lastnr=nr;
			} else {
				if (firstofsequence>=0) {
					// remove all in between!
					// 2 001 <- firstofsequence
					// 3 002
					// 4 003
					// 5 bla <-index which isn't a match
					__int64 totalsize=((__int64)resultlist[firstofsequence]->nFileSizeHigh)<<32 | resultlist[firstofsequence]->nFileSizeLow;
					for (int j=firstofsequence+1;j<index;j++) {
						totalsize+=((__int64)resultlist[j]->nFileSizeHigh)<<32 | resultlist[j]->nFileSizeLow;
						free(resultlist[j]);
					}
					resultlist[firstofsequence]->nFileSizeHigh=totalsize>>32;
					resultlist[firstofsequence]->nFileSizeLow=totalsize & 0xffffffff;
					memmove(&resultlist[firstofsequence+1],&resultlist[index],(count-index)*sizeof(LPWIN32_FIND_DATAW));
					count-=(index-firstofsequence-1);
					index=firstofsequence;
					buildNewName(wlastnrstart,wlasnrmax,lastnr);
					firstofsequence=-1;
				}
				wlastnrstart=NULL;
				lastnr=-1;
			}
			wlastname=wname;
		}
		if (firstofsequence>=0 && wlastnrstart!=NULL) {
			// remove all in between!
			// 2 001 <- firstofsequence
			// 3 002
			// 4 003
			// <-nr which isn't a match
			__int64 totalsize=((__int64)resultlist[firstofsequence]->nFileSizeHigh)<<32 | resultlist[firstofsequence]->nFileSizeLow;
			for (int j=firstofsequence+1;j<count;j++) {
				totalsize+=((__int64)resultlist[j]->nFileSizeHigh)<<32 | resultlist[j]->nFileSizeLow;
				free(resultlist[j]);
			}
			resultlist[firstofsequence]->nFileSizeHigh=totalsize>>32;
			resultlist[firstofsequence]->nFileSizeLow=totalsize & 0xffffffff;
			buildNewName(wlastnrstart,wlasnrmax,lastnr);
			count=firstofsequence+1;
		}
	}
	*resultlistret=resultlist;
	return count;
}

HANDLE __stdcall FsFindFirstW(WCHAR* Path,WIN32_FIND_DATAW *FindData)
{
	WCHAR buf[wdirtypemax];
	pLastFindStuct lf;
	
	memset(FindData,0,sizeof(WIN32_FIND_DATAW));
	if (wcscmp(Path,L"\\")==0) {
		FindData->dwFileAttributes=FILE_ATTRIBUTE_DIRECTORY;
		FindData->ftLastWriteTime.dwHighDateTime=0xFFFFFFFF;
		FindData->ftLastWriteTime.dwLowDateTime=0xFFFFFFFE;
		lf=(pLastFindStuct)malloc(sizeof(tLastFindStuct));
		wcslcpy(lf->PathW,Path,countof(lf->PathW)-1);
		lf->searchroot=true;
		char ch='A';
		wcscpy(buf,L"A:\\");
		while (GetDriveTypeW(buf)==DRIVE_NO_ROOT_DIR && ch<'Z'+1) {
			ch++;
			buf[0]=ch;
		}
		buf[2]=0;
		if (ch<='Z') {
			wcslcpy(lf->LastFoundNameW,buf,countof(lf->LastFoundNameW)-1);
			wcslcpy(FindData->cFileName,buf,countof(FindData->cFileName)-1);
			return (HANDLE)lf;
		} else {
			free(lf);
			return INVALID_HANDLE_VALUE;
		}
	} else {
		LPWIN32_FIND_DATAW* resultlist;
		resultlist=NULL;
		int count=ReadWholeDirectoryW(Path+pluginrootlen,&resultlist);
		if (count==0)
			return INVALID_HANDLE_VALUE;
		else {
			lf=(pLastFindStuct)malloc(sizeof(tLastFindStuct));
			lf->searchroot=false;
			lf->resultlist=resultlist;
			lf->index=1;
			lf->count=count;
			memcpy(FindData,lf->resultlist[0],sizeof(WIN32_FIND_DATAW));
			return (HANDLE)lf;
		}
	}
	return INVALID_HANDLE_VALUE;
}

HANDLE __stdcall FsFindFirst(char* Path,WIN32_FIND_DATA *FindData)
{
	WIN32_FIND_DATAW FindDataW;
	WCHAR PathW[wdirtypemax];
	HANDLE retval=FsFindFirstW(awfilenamecopy(PathW,Path),&FindDataW);
	if (retval!=INVALID_HANDLE_VALUE)
		copyfinddatawa(FindData,&FindDataW);
	return retval;
}

BOOL __stdcall FsFindNextW(HANDLE Hdl,WIN32_FIND_DATAW *FindData)
{
	WCHAR buf[wdirtypemax];
	pLastFindStuct lf;

	if ((int)Hdl==1)
		return false;

	lf=(pLastFindStuct)Hdl;
	if (lf->searchroot) {   // drive list!
		char ch=(char)lf->LastFoundNameW[0];
		wcscpy(buf,L"A:\\");
		buf[0]=ch+1;
		while (GetDriveTypeW(buf)==DRIVE_NO_ROOT_DIR && ch<'Z'+1) {
			ch++;
			buf[0]=ch;
		}
		buf[2]=0;
		if (ch<='Z') {
			wcslcpy(lf->LastFoundNameW,buf,countof(lf->LastFoundNameW)-1);
			wcslcpy(FindData->cFileName,buf,countof(FindData->cFileName)-1);
			return true;
		} else {
			return false;
		}

	} else {
		lf=(pLastFindStuct)Hdl;
		if (lf->index<lf->count) {
			memcpy(FindData,lf->resultlist[lf->index],sizeof(WIN32_FIND_DATAW));
			lf->index++;
			return true;
		}
	}
	return false;
}

BOOL __stdcall FsFindNext(HANDLE Hdl,WIN32_FIND_DATA *FindData)
{
	WIN32_FIND_DATAW FindDataW;
	copyfinddataaw(&FindDataW,FindData);
	BOOL retval=FsFindNextW(Hdl,&FindDataW);
	if (retval)
		copyfinddatawa(FindData,&FindDataW);
	return retval;
}

int __stdcall FsFindClose(HANDLE Hdl)
{
	if ((int)Hdl==1)
		return 0;
	pLastFindStuct lf;
	lf=(pLastFindStuct)Hdl;
	if (!lf->searchroot) {
		if (lf->resultlist && lf->count>0) {
			for (int i=0;i<lf->count;i++)
				free(lf->resultlist[i]);
		}
		free(lf->resultlist);
		lf->resultlist=NULL;
	}
	free(lf);
	return 0;
}

BOOL __stdcall FsMkDir(char* Path)
{
	WCHAR wbuf[wdirtypemax];
	return FsMkDirW(awfilenamecopy(wbuf,Path));
}

BOOL __stdcall FsMkDirW(WCHAR* Path)
{
	if (wcslen(Path)<pluginrootlen+2)
		return false;
	return CreateDirectoryT(Path+pluginrootlen,NULL);
}

int __stdcall FsExecuteFile(HWND MainWin,char* RemoteName,char* Verb)
{
    SHELLEXECUTEINFO shex;
	if (strlen(RemoteName)<pluginrootlen+2)
		return FS_EXEC_ERROR;
	if (stricmp(Verb,"open")==0) {
		return FS_EXEC_YOURSELF;
	} else if (stricmp(Verb,"properties")==0) {
		UseSequenceView=!UseSequenceView;
		return FS_EXEC_SYMLINK;
	} else
		return FS_EXEC_ERROR;
}

int CountDigits(WCHAR* name) {
	int digits=0;
	while (name[digits]) {
		if (name[digits]<'0' || name[digits]>'9')
			return -1;
		digits++;
	}
	return digits;
}

BOOL GetFileNameRange(WCHAR* name,int* start, int* end, int* digits) {
	WCHAR buf[128];
	WCHAR* p=wcsrchr(name,'<');
	if (!p)
		return false;
	wcslcpy(buf,p+1,COUNTOF(buf)-1);
	p=wcsrchr(buf,'>');
	if (!p)
		return false;
	p[0]=0;
	p=wcsrchr(buf,'-');
	if (p) {
		p[0]=0;
		if (p[1]==0)
			*end=-1;
		else {
			if (CountDigits(p+1)<0)
				return false;
			*end=_wtoi(p+1);
		}
	} else
		*end=-1;
	int dgt=CountDigits(buf);
	if (dgt<0)
		return false;
	*digits=dgt;
	*start=_wtoi(buf);
	return true;
}

BOOL CreateNumberedFileName(WCHAR* Target,int maxlen,WCHAR* RemoteName,int number,int digits) {
	WCHAR buf[128];
	WCHAR* p=wcsrchr(RemoteName,'<');
	if (!p)
		return false;
	WCHAR* p2=wcsrchr(p,'>');
	if (!p2)
		return false;
	p[0]=0;
	wcslcpy(Target,RemoteName,maxlen);
	p[0]='<';
	_itow(number,buf,10);
	int remain=digits-(int)wcslen(buf);
	while (remain-->0)
		wcslcat(Target,L"0",maxlen);
	wcslcat(Target,buf,maxlen);
	wcslcat(Target,p2+1,maxlen);
	return wcslen(Target)<maxlen;
}

HWND GlobalMainWin;
WCHAR* GlobalFileName;

void MenuDlg_SetupWindow(MSG msg) {
	HWND lbox=GetDlgItem(msg.hwnd,ID_LISTBOX);

	WIN32_FIND_DATAW fd;
	WCHAR settingsname[MAX_PATH+1];
	awlcopy(settingsname,inifilename,MAX_PATH);
	WCHAR* nameptr=wcsrchr(settingsname,'\\');
	if (nameptr) {
		nameptr[1]=0;
		wcslcat(nameptr,L"SequenceView.ini",MAX_PATH);
	}
	HANDLE hdl=FindFirstFileW(settingsname,&fd);
	if (hdl!=INVALID_HANDLE_VALUE)
		FindClose(hdl);
	else {
		HANDLE f=CreateFileW(settingsname,GENERIC_WRITE,FILE_SHARE_READ,NULL,
				CREATE_ALWAYS,0,NULL);
		if (f!=INVALID_HANDLE_VALUE) {
			WCHAR buf[256];
			wcslcpy(buf,L"B[SequenceView]\r\nOpen first=%D%F\r\n;Usage: Menu=command\r\n; Placeholders:\r\n; %F first file name\r\n; %L last file name\r\n; %P path name\r\n; %B base name (without counter)\r\n; %X eXtension\r\n; %S start nr\r\n; %E end nr\r\n; %C file count",countof(buf)-1);
			buf[0]=0xFEFF;
			DWORD written;
			WriteFile(f,buf,2*wcslen(buf),&written,NULL);
			CloseHandle(f);
		}
	}
	WCHAR namelist[32768],*namelistptr;
	namelist[0]=0;
	namelistptr=namelist;
	GetPrivateProfileStringW(L"SequenceView",NULL,L"",namelist,COUNTOF(namelist),settingsname);
	while (namelistptr[0]) {
		SendMessageW(lbox,LB_ADDSTRING,0,(LPARAM)namelistptr);
		namelistptr+=wcslen(namelistptr)+1;
	}
	SendMessageW(lbox,LB_SETCARETINDEX,0,0);
	SendMessageW(lbox,LB_SETSEL,(WPARAM)-1,0);
	RECT rt1,rt2;
	int w,h,DlgWidth,DlgHeight,NewPosX,NewPosY;
	if (GetWindowRect(msg.hwnd, &rt1) && GetWindowRect(GetParent(msg.hwnd), &rt2)) {
		w=rt2.right-rt2.left;
		h=rt2.bottom-rt2.top;
		DlgWidth   = rt1.right - rt1.left;
		DlgHeight   = rt1.bottom - rt1.top ;
		NewPosX      =rt2.left + (w - DlgWidth)/2;
		NewPosY      =rt2.top + (h - DlgHeight)/2;
		SetWindowPos(msg.hwnd, 0, NewPosX, NewPosY,
			0, 0, SWP_NOZORDER | SWP_NOSIZE);
	}
}

void ExecuteCommand(HWND Dialog,WCHAR* command1) {
	WCHAR command2[8192];
	WCHAR name[1024];
	command2[0]=0;
	WCHAR* p=command1;
	WCHAR* q=command2;
	WCHAR* qend=q+COUNTOF(command2)-2;
	WCHAR* pName;
	WCHAR* pParams=NULL;
	while (p[0] && q<qend) {
		if (p[0]=='%') {
			switch (p[1]) {
				case '%':
					q[0]='%';
					q++;
					p++;
					break;
				case 'P':    // path
					q[0]=0;
					wcslcat(command2,GlobalFileName,COUNTOF(name)-1);
					pName=wcsrchr(q,'\\');
					if (pName)
						pName[1]=0;
					q+=wcslen(q);
					p++;
					break;
				case 'B':   // base name without number
					pName=wcsrchr(GlobalFileName,'\\');
					if (pName)
						pName++;
					else
						pName=GlobalFileName;
					q[0]=0;
					wcslcat(command2,pName,COUNTOF(name)-1);
					pName=wcschr(q,'<');
					if (pName)
						pName[0]=0;
					else {
						pName=wcsrchr(q,'.');
						if (pName)
							pName[0]=0;
					}
					q+=wcslen(q);
					p++;
					break;
				case 'X':   // eXtension
					pName=wcsrchr(GlobalFileName,'\\');
					if (!pName)
						pName=GlobalFileName;
					pName=wcsrchr(pName,'.');
					if (pName) {
						q[0]=0;
						wcslcat(command2,pName,COUNTOF(name)-1);
						q+=wcslen(q);
					}
					p++;
					break;
				case 'F':   // first file name
				case 'L':   // last file name
					{
						int start=-1;
						int end=-1;
						int digits=-1;
						if (GetFileNameRange(GlobalFileName,&start,&end,&digits)) {
							WCHAR SingleRemoteName[MAX_PATH+1];
							if (CreateNumberedFileName(SingleRemoteName,MAX_PATH,GlobalFileName,(p[1]=='F')?start:end,digits)) {
								pName=wcsrchr(SingleRemoteName,'\\');
								if (pName)
									pName++;
								else
									pName=SingleRemoteName;
								q[0]=0;
								wcslcat(command2,pName,COUNTOF(name)-1);
							}
						} else {
							pName=wcsrchr(GlobalFileName,'\\');
							if (pName)
								pName++;
							else
								pName=GlobalFileName;
							q[0]=0;
							wcslcat(command2,pName,COUNTOF(name)-1);
						}
						q+=wcslen(q);
						p++;
					}
					break;
				case 'S':   // start nr
				case 'E':   // end nr
				case 'C':   // file count
					{
						int start=-1;
						int end=-1;
						int digits=-1;
						q[0]=0;
						if (GetFileNameRange(GlobalFileName,&start,&end,&digits)) {
							WCHAR nrstr[32];
							if (p[1]=='S')
								_itow(start,nrstr,10);
							else if (p[1]=='E')
								_itow(end,nrstr,10);
							else
								_itow(end-start+1,nrstr,10);
							if (p[1]!='C') {
								int remain=digits-(int)wcslen(nrstr);
								while (remain-->0) {
									q[0]='0';
									q++;
								}
								q[0]=0;
							}
							wcslcat(command2,nrstr,COUNTOF(name)-1);
						} else {

							wcslcat(command2,p[1]!='C'?L"1":L"0",COUNTOF(name)-1);
						}
						q+=wcslen(q);
						p++;
					}
					break;
			}
			p++;
		} else {
			q[0]=p[0];
			q++;
			p++;
		}
	}
	q[0]=0;
	if (command2[0]=='"') {
		pParams=wcschr(command2+1,'"');
		if (pParams && pParams[1]==' ') {
			pParams[1]=0;
			pParams+=2;
		} else
			pParams=NULL;
	} else {
		pParams=wcschr(command2+1,' ');
		if (pParams) {
			pParams[0]=0;
			pParams++;
		}
	}
	SHELLEXECUTEINFOW shex;
	memset(&shex,0,sizeof(shex));
	shex.fMask=SEE_MASK_INVOKEIDLIST;
	shex.cbSize=sizeof(shex); 
	shex.nShow=SW_SHOW;
	shex.hwnd=Dialog;
	shex.lpVerb=NULL;
	shex.lpFile=command2;
	shex.lpParameters=pParams;
	ShellExecuteExW(&shex);

}

INT_PTR __stdcall MenuDlgProc(HWND Dialog,unsigned int Message,WPARAM wParam,LPARAM lParam)
{
        MSG msg;
        msg.hwnd=Dialog;
        msg.message=Message;
        msg.wParam=wParam;
        msg.lParam=lParam;
        switch (Message) {
        case WM_INITDIALOG: {
                MenuDlg_SetupWindow(msg);
                return 1;
                break;
		}
/*        case WM_CTLCOLORDLG: {
                if (HIWORD(lParam)!=CTLCOLOR_LISTBOX) {
                        SetBkColor((HDC)wParam,GetSysColor(COLOR_BTNFACE));
                        SetTextColor((HDC)wParam,GetSysColor(COLOR_BTNTEXT));
                        return((INT_PTR)br);
                } else
                        return(0);
        break;
        }*/
        case WM_COMMAND: {
			WCHAR settingsname[MAX_PATH+1];
			WCHAR entry[MAX_PATH+1];
			awlcopy(settingsname,inifilename,MAX_PATH);
			WCHAR* nameptr=wcsrchr(settingsname,'\\');
			if (nameptr) {
				nameptr[1]=0;
				wcslcat(nameptr,L"SequenceView.ini",MAX_PATH);
			}
            switch(LOWORD(wParam)) {
                case IDOK: {
                    //TLanguageDlg_Ok(msg);
					int i=SendDlgItemMessage(Dialog,ID_LISTBOX,LB_GETCARETINDEX,0,0);
					if (i<0)
						i=0;
					entry[0]=0;
					SendDlgItemMessageW(Dialog,ID_LISTBOX,LB_GETTEXT,i,(LPARAM)&entry);
					if (entry[0]) {
						WCHAR command[1024];
						command[0]=0;
						GetPrivateProfileStringW(L"SequenceView",entry,L"",command,COUNTOF(command)-1,settingsname);
						if (command[0])
							ExecuteCommand(Dialog,command);
					}							
                    EndDialog(Dialog, IDOK);
                    return 1;
                }
                case IDCANCEL: {
                    EndDialog(Dialog, IDCANCEL);
                    return 1;
                }
				case ID_CONFIGURE: {
					SHELLEXECUTEINFOW shex;
					memset(&shex,0,sizeof(shex));
					shex.fMask=SEE_MASK_INVOKEIDLIST;
					shex.cbSize=sizeof(shex);
					shex.nShow=SW_SHOW;
					shex.hwnd=Dialog;
					shex.lpVerb=NULL;
					shex.lpFile=settingsname;
					ShellExecuteExW(&shex);
                    EndDialog(Dialog, IDCANCEL);
					return 1;
				}
			}
		}
		}
        return 0;
}

void ShowContextMenuForFile(HWND MainWin,WCHAR* FileName) {
	GlobalMainWin=MainWin;
	GlobalFileName=FileName;
	DialogBoxW((HINSTANCE)hinst,MAKEINTRESOURCEW(IDD_DIALOG1),MainWin,MenuDlgProc);
}

int __stdcall FsExecuteFileW(HWND MainWin,WCHAR* RemoteName,WCHAR* Verb)
{
    SHELLEXECUTEINFOW shex;
	if (wcslen(RemoteName)<pluginrootlen+2)
		return FS_EXEC_ERROR;

	if (wcsicmp(Verb,L"open")==0) {
		ShowContextMenuForFile(MainWin,RemoteName+pluginrootlen);
		return FS_EXEC_OK;
	} else if (wcsicmp(Verb,L"properties")==0) {
		UseSequenceView=!UseSequenceView;
		PostMessage(GetActiveWindow(),WM_USER+51,540,0); // RE-READ SOURCE
		return FS_EXEC_OK;
	} else
		return FS_EXEC_ERROR;
}

int __stdcall FsRenMovFile(char* OldName,char* NewName,BOOL Move,BOOL OverWrite,RemoteInfoStruct* ri)
{
	WCHAR OldNameW[wdirtypemax],NewNameW[wdirtypemax];
	return FsRenMovFileW(awfilenamecopy(OldNameW,OldName),awfilenamecopy(NewNameW,NewName),Move,OverWrite,ri);
}

int FsRenMovSingleFileW(WCHAR* OldName,WCHAR* NewName,BOOL Move,BOOL OverWrite,RemoteInfoStruct* ri)
{
	if (wcslen(OldName)<pluginrootlen+2 || wcslen(NewName)<pluginrootlen+2)
		return FS_FILE_NOTFOUND;

	if (Move) {
		if (OverWrite)
			DeleteFileT(NewName+pluginrootlen);
		if (MoveFileT(OldName+pluginrootlen,NewName+pluginrootlen))
			return FS_FILE_OK;
	} else {
		if (CopyFileT(OldName+pluginrootlen,NewName+pluginrootlen,!OverWrite))
			return FS_FILE_OK;
	}
	switch(GetLastError()) {
		case ERROR_FILE_NOT_FOUND:
		case ERROR_PATH_NOT_FOUND:
		case ERROR_ACCESS_DENIED:
			return FS_FILE_NOTFOUND;
		case ERROR_FILE_EXISTS:
			return FS_FILE_EXISTS;
		default:
			return FS_FILE_WRITEERROR;
	}
}

int __stdcall FsRenMovFileW(WCHAR* OldName,WCHAR* NewName,BOOL Move,BOOL OverWrite,RemoteInfoStruct* ri)
{
	if (wcslen(OldName)<pluginrootlen+2 || wcslen(NewName)<pluginrootlen+2)
		return FS_FILE_NOTFOUND;

	int err=ProgressProcT(PluginNumber,OldName,NewName,0);
	if (err)
		return FS_FILE_USERABORT;

	int start=-1;
	int end=-1;
	int digits=-1;
	if (GetFileNameRange(OldName,&start,&end,&digits)) {
		int start2=-1;
		int end2=-1;
		int digits2=-1;
		if (!GetFileNameRange(NewName,&start2,&end2,&digits2)) {
			MessageBox(GetActiveWindow(),"Error: You must specify a range also for the target!","SequenceView",MB_ICONSTOP);
			return FS_FILE_WRITEERROR;
		}
		if (end2==-1)
			end2=start2+(end-start);
		if (end2-start2!=end-start) {
			MessageBox(GetActiveWindow(),"Error: The range of the target differs from the range of the source, cannot rename!","SequenceView",MB_ICONSTOP);
			return FS_FILE_WRITEERROR;
		}
		int idx=start;
		int finish=end+1;
		int idx2=start2;
		int step=1;
		int numcopied=1; 
		if (start2>start && start2<=end) {  // reverse counter to avoid overlap!
			idx=end;
			finish=start-1;
			idx2=end2;
			step=-1;
		}
		while (idx!=finish) {
			WCHAR SingleOldName[MAX_PATH+1];
			WCHAR SingleNewName[MAX_PATH+1];
			if (CreateNumberedFileName(SingleOldName,MAX_PATH,OldName,idx,digits)) {
				if (CreateNumberedFileName(SingleNewName,MAX_PATH,NewName,idx2,digits2)) {
					int ret=FsRenMovSingleFileW(SingleOldName,SingleNewName,Move,false,ri);
					if (ret==FS_FILE_EXISTS)
						ret=FS_FILE_WRITEERROR;
					messageloop();
					if (ProgressProcT(PluginNumber,OldName,NewName,100*numcopied/(end-start+1)))
						return FS_FILE_USERABORT;
					messageloop();
					if (ret!=FS_FILE_OK)
						return ret;
				}
			}
			idx+=step;
			idx2+=step;
			numcopied++;
		}
		return FS_FILE_OK;
	}

	int ret=FsRenMovSingleFileW(OldName,NewName,Move,OverWrite,ri);
	if (ProgressProcT(PluginNumber,OldName,NewName,100))
		return FS_FILE_USERABORT;
	return ret;
}

int __stdcall FsGetFileW(WCHAR* RemoteName,WCHAR* LocalName,int CopyFlags,RemoteInfoStruct* ri)
{
    int err;
	BOOL ok,OverWrite,Resume,Move;

	OverWrite=CopyFlags & FS_COPYFLAGS_OVERWRITE;
	Resume=CopyFlags & FS_COPYFLAGS_RESUME;
	Move=CopyFlags & FS_COPYFLAGS_MOVE;

	int start=-1;
	int end=-1;
	int digits=-1;
	if (GetFileNameRange(RemoteName,&start,&end,&digits)) {
		WCHAR SingleRemoteName[MAX_PATH+1];
		if (CreateNumberedFileName(SingleRemoteName,MAX_PATH,RemoteName,start,digits)) {
			return FsGetFileW(SingleRemoteName,LocalName,CopyFlags,ri);
		}
		return FS_FILE_READERROR;
	}

	if (Resume)
		return FS_FILE_NOTSUPPORTED;

	if (wcslen(RemoteName)<pluginrootlen+2)
		return FS_FILE_NOTFOUND;
	
	err=ProgressProcT(PluginNumber,RemoteName,LocalName,0);
	if (err)
		return FS_FILE_USERABORT;
	if (Move) {
		if (OverWrite)
			DeleteFileT(LocalName);
		ok=MoveFileT(RemoteName+pluginrootlen,LocalName);
	} else
		ok=CopyFileT(RemoteName+pluginrootlen,LocalName,!OverWrite);
	
	if (ok) {
		ProgressProcT(PluginNumber,RemoteName,LocalName,100);
		return FS_FILE_OK;
	} else {
		err=GetLastError();
		switch (err) {
		case 2:
		case 3:
		case 4:
		case 5:
			return FS_FILE_NOTFOUND;
		case ERROR_FILE_EXISTS:
			return FS_FILE_EXISTS;
		default:
			return FS_FILE_READERROR;
		}
	}
}

int __stdcall FsGetFile(char* RemoteName,char* LocalName,int CopyFlags,RemoteInfoStruct* ri)
{
	WCHAR RemoteNameW[wdirtypemax],LocalNameW[wdirtypemax];
	return FsGetFileW(awfilenamecopy(RemoteNameW,RemoteName),awfilenamecopy(LocalNameW,LocalName),CopyFlags,ri);
}

int __stdcall FsPutFileW(WCHAR* LocalName,WCHAR* RemoteName,int CopyFlags)
{
    int err;
	BOOL ok,OverWrite,Resume,Move;

	OverWrite=CopyFlags & FS_COPYFLAGS_OVERWRITE;
	Resume=CopyFlags & FS_COPYFLAGS_RESUME;
	Move=CopyFlags & FS_COPYFLAGS_MOVE;
	if (Resume)
		return FS_FILE_NOTSUPPORTED;

	if (wcslen(RemoteName)<pluginrootlen+2)
		return FS_FILE_NOTFOUND;
	
	err=ProgressProcT(PluginNumber,LocalName,RemoteName,0);
	if (err)
		return FS_FILE_USERABORT;
	if (Move) {
		if (OverWrite)
			DeleteFileT(RemoteName+pluginrootlen);
		ok=MoveFileT(LocalName,RemoteName+pluginrootlen);
	} else
		ok=CopyFileT(LocalName,RemoteName+pluginrootlen,!OverWrite);

	if (ok) {
		ProgressProcT(PluginNumber,RemoteName,LocalName,100);
		return FS_FILE_OK;
	} else {
		err=GetLastError();
		switch (err) {
		case 2:
		case 3:
		case 4:
		case 5:
			return FS_FILE_NOTFOUND;
		case ERROR_FILE_EXISTS:
			return FS_FILE_EXISTS;
		default:
			return FS_FILE_READERROR;
		}
	}
}

int __stdcall FsPutFile(char* LocalName,char* RemoteName,int CopyFlags)
{
	WCHAR LocalNameW[wdirtypemax],RemoteNameW[wdirtypemax];
	return FsPutFileW(awfilenamecopy(LocalNameW,LocalName),awfilenamecopy(RemoteNameW,RemoteName),CopyFlags);
}

BOOL __stdcall FsDeleteFileW(WCHAR* RemoteName)
{
	if (wcslen(RemoteName)<pluginrootlen+2)
		return false;

	int start=-1;
	int end=-1;
	int digits=-1;

	if (GetFileNameRange(RemoteName,&start,&end,&digits)) {
		WCHAR msgbuf[1024];
		WCHAR Target[MAX_PATH+1];
		wsprintfW(msgbuf,L"WARNING: This will delete %d files DIRECTLY (no recycle bin)!\n\n",end-start+1);
		WCHAR* p=wcsrchr(RemoteName,'\\')+1;
		if (CreateNumberedFileName(Target,MAX_PATH,p,start,digits)) {
			wcslcat(msgbuf,Target,1023);
			wcslcat(msgbuf,L"\n...\n",1023);
		} else
			return false;
		if (CreateNumberedFileName(Target,MAX_PATH,p,end,digits))
			wcslcat(msgbuf,Target,1023);
		else
			return false;
		wcslcat(msgbuf,L"\n\nProceed?",1023);
		if (MessageBoxW(GetActiveWindow(),msgbuf,L"SequenceView",MB_YESNO | MB_DEFBUTTON2)==IDNO)
			return false;
		int numcopied=1;
		for (int i=start;i<=end;i++) {
			if (CreateNumberedFileName(Target,MAX_PATH,RemoteName,i,digits)) {
				if (!DeleteFileT(Target+pluginrootlen))
					return false;
				messageloop();
				if (ProgressProcT(PluginNumber,RemoteName,NULL,100*numcopied/(end-start+1)))
					return FS_FILE_USERABORT;
				messageloop();
				numcopied++;
			}
		}
		return true;
	}
	return DeleteFileT(RemoteName+pluginrootlen);	
}

BOOL __stdcall FsDeleteFile(char* RemoteName)
{
	WCHAR RemoteNameW[wdirtypemax];
	return FsDeleteFileW(awfilenamecopy(RemoteNameW,RemoteName));
}

BOOL __stdcall FsRemoveDirW(WCHAR* RemoteName)
{
	if (wcslen(RemoteName)<pluginrootlen+2)
		return false;

	return RemoveDirectoryT(RemoteName+pluginrootlen);	
}

BOOL __stdcall FsRemoveDir(char* RemoteName)
{
	WCHAR RemoteNameW[wdirtypemax];
	return FsRemoveDirW(awfilenamecopy(RemoteNameW,RemoteName));
}

BOOL __stdcall FsSetAttrW(WCHAR* RemoteName,int NewAttr)
{
	if (wcslen(RemoteName)<pluginrootlen+2)
		return false;

	int start=-1;
	int end=-1;
	int digits=-1;

	if (GetFileNameRange(RemoteName,&start,&end,&digits)) {
		WCHAR Target[MAX_PATH+1];
		int numchanged=1;
		for (int i=start;i<=end;i++) {
			if (CreateNumberedFileName(Target,MAX_PATH,RemoteName,i,digits)) {
				if (!SetFileAttributesT(Target+pluginrootlen,NewAttr))
					return false;
				messageloop();
				if (ProgressProcT(PluginNumber,RemoteName,NULL,100*numchanged/(end-start+1)))
					return FS_FILE_USERABORT;
				messageloop();
				numchanged++;
			}
		}
		return true;
	}

	if (NewAttr==0)
		NewAttr=FILE_ATTRIBUTE_NORMAL;
	return SetFileAttributesT(RemoteName+pluginrootlen,NewAttr);	
}

BOOL __stdcall FsSetAttr(char* RemoteName,int NewAttr)
{
	WCHAR RemoteNameW[wdirtypemax];
	return FsSetAttrW(awfilenamecopy(RemoteNameW,RemoteName),NewAttr);
}

BOOL __stdcall FsSetTimeW(WCHAR* RemoteName,FILETIME *CreationTime,
      FILETIME *LastAccessTime,FILETIME *LastWriteTime)
{
	if (wcslen(RemoteName)<pluginrootlen+2)
		return false;

	int start=-1;
	int end=-1;
	int digits=-1;

	if (GetFileNameRange(RemoteName,&start,&end,&digits)) {
		WCHAR Target[MAX_PATH+1];
		int numchanged=1;
		for (int i=start;i<=end;i++) {
			if (CreateNumberedFileName(Target,MAX_PATH,RemoteName,i,digits)) {
				if (!FsSetTimeW(Target,CreationTime,LastAccessTime,LastWriteTime))
					return false;
				messageloop();
				if (ProgressProcT(PluginNumber,RemoteName,NULL,100*numchanged/(end-start+1)))
					return FS_FILE_USERABORT;
				messageloop();
				numchanged++;
			}
		}
		return true;
	}

	HANDLE filehandle = CreateFileT(RemoteName+pluginrootlen,	
                      GENERIC_WRITE,          // Open for writing
                      0,                      // Do not share
                      NULL,                   // No security
                      OPEN_EXISTING,          // Existing file only
                      FILE_ATTRIBUTE_NORMAL,  // Normal file
                      NULL);

	if (filehandle==INVALID_HANDLE_VALUE)
		return FALSE;

	BOOL retval=SetFileTime(filehandle,CreationTime,LastAccessTime,LastWriteTime);
    CloseHandle(filehandle);
	return retval;
}

BOOL __stdcall FsSetTime(char* RemoteName,FILETIME *CreationTime,
      FILETIME *LastAccessTime,FILETIME *LastWriteTime)
{
	WCHAR RemoteNameW[wdirtypemax];
	return FsSetTimeW(awfilenamecopy(RemoteNameW,RemoteName),CreationTime,
		LastAccessTime,LastWriteTime);
}

void __stdcall FsStatusInfo(char* RemoteDir,int InfoStartEnd,int InfoOperation)
{
	// This function may be used to initialize variables and to flush buffers
	
/*	char text[wdirtypemax];

	if (InfoStartEnd==FS_STATUS_START)
		strcpy(text,"Start: ");
	else
		strcpy(text,"End: ");
	
	switch (InfoOperation) {
	case FS_STATUS_OP_LIST:
		strcat(text,"Get directory list");
		break;
	case FS_STATUS_OP_GET_SINGLE:
		strcat(text,"Get single file");
		break;
	case FS_STATUS_OP_GET_MULTI:
		strcat(text,"Get multiple files");
		break;
	case FS_STATUS_OP_PUT_SINGLE:
		strcat(text,"Put single file");
		break;
	case FS_STATUS_OP_PUT_MULTI:
		strcat(text,"Put multiple files");
		break;
	case FS_STATUS_OP_RENMOV_SINGLE:
		strcat(text,"Rename/Move/Remote copy single file");
		break;
	case FS_STATUS_OP_RENMOV_MULTI:
		strcat(text,"Rename/Move/Remote copy multiple files");
		break;
	case FS_STATUS_OP_DELETE:
		strcat(text,"Delete multiple files");
		break;
	case FS_STATUS_OP_ATTRIB:
		strcat(text,"Change attributes of multiple files");
		break;
	case FS_STATUS_OP_MKDIR:
		strcat(text,"Create directory");
		break;
	case FS_STATUS_OP_EXEC:
		strcat(text,"Execute file or command line");
		break;
	case FS_STATUS_OP_CALCSIZE:
		strcat(text,"Calculate space occupied by a directory");
		break;
	case FS_STATUS_OP_SEARCH:
		strcat(text,"Search for file names");
		break;
	case FS_STATUS_OP_SEARCH_TEXT:
		strcat(text,"Search for text in files");
		break;
	case FS_STATUS_OP_SYNC_SEARCH:
		strcat(text,"Search files for sync comparison");
		break;
	case FS_STATUS_OP_SYNC_GET:
		strcat(text,"download files during sync");
		break;
	case FS_STATUS_OP_SYNC_PUT:
		strcat(text,"Upload files during sync");
		break;
	case FS_STATUS_OP_SYNC_DELETE:
		strcat(text,"Delete files during sync");
		break;
	default:
		strcat(text,"Unknown operation");
	}
	if (InfoOperation != FS_STATUS_OP_LIST)   // avoid recursion due to re-reading!
		MessageBox(0,text,RemoteDir,0);
*/
}

void __stdcall FsGetDefRootName(char* DefRootName,int maxlen)
{
	strlcpy(DefRootName,"SequenceView",maxlen);
}

int __stdcall FsExtractCustomIconW(WCHAR* RemoteName,int ExtractFlags,HICON* TheIcon)
{
	WCHAR* p;
	BOOL success,isdirectory;

	if (!RemoteName[0])
		return FS_ICON_USEDEFAULT;

	int start=-1;
	int end=-1;
	int digits=-1;
	if (GetFileNameRange(RemoteName,&start,&end,&digits)) {
		WCHAR SingleRemoteName[MAX_PATH+1];
		if (CreateNumberedFileName(SingleRemoteName,MAX_PATH,RemoteName,start,digits)) {
			return FsExtractCustomIconW(SingleRemoteName,ExtractFlags,TheIcon);
		}
		return FS_ICON_USEDEFAULT;
	}

	// Note: directories have a backslash at the end!
	p=RemoteName+wcslen(RemoteName)-1;
	isdirectory=p[0]=='\\';

	if (isdirectory) {
		// Sample: show drive icons for drive level
		if (wcslen(RemoteName)<=4 && wcscmp(RemoteName,L"\\..\\")!=0) {
			if (ExtractFlags & FS_ICONFLAG_SMALL)  // use LoadImage, because LoadIcon produces ugly results
				*TheIcon=(HICON)LoadImage((HINSTANCE)hinst,MAKEINTRESOURCE(IDI_ICON2),IMAGE_ICON,16,16,LR_SHARED);
			else
				*TheIcon=LoadIcon((HINSTANCE)hinst,MAKEINTRESOURCE(IDI_ICON2));
			wcscpy(RemoteName,L"ICON2");   // Use it as identifier so the icon is only stored once
			return FS_ICON_EXTRACTED;
		}
	} else {	
		// Sample: extract custom icons for EXE files
		p=wcsrchr(RemoteName,'.');
		if (p && wcsicmp(p,L".exe")==0) {
			if (ExtractFlags & FS_ICONFLAG_BACKGROUND) {
				if (ExtractFlags & FS_ICONFLAG_SMALL)
					success=ExtractIconExT(RemoteName+pluginrootlen,0,NULL,TheIcon,1)==1;
				else
					success=ExtractIconExT(RemoteName+pluginrootlen,0,TheIcon,NULL,1)==1;
				if (success)
					return FS_ICON_EXTRACTED_DESTROY;  // must be destroyed with DestroyIcon!!!
			} else
				return FS_ICON_DELAYED;
		}
	}
	return FS_ICON_USEDEFAULT;
}

int __stdcall FsExtractCustomIcon(char* RemoteName,int ExtractFlags,HICON* TheIcon)
{
	WCHAR RemoteNameW[wdirtypemax],OldNameW[wdirtypemax];
	awfilenamecopy(RemoteNameW,RemoteName);
	wcscpy(OldNameW,RemoteNameW);
	int retval=FsExtractCustomIconW(RemoteNameW,ExtractFlags,TheIcon);
	if (wcscmp(OldNameW,RemoteNameW)!=0)
		wafilenamecopy(RemoteName,RemoteNameW);
	return retval;
}

int __stdcall FsGetPreviewBitmap(char* RemoteName,int width,int height,HBITMAP* ReturnedBitmap)
{
	if (strlen(RemoteName)<=4) {
		 if (strcmp(RemoteName,"\\..\\")==0)
			 return FS_BITMAP_NONE;
		 else {
			int w,h,bigx,bigy;
			int stretchx,stretchy;
			OSVERSIONINFO vx;
			BOOL is_nt;
			BITMAP bmpobj;
			HBITMAP bmp_image,bmp_thumbnail,oldbmp_image,oldbmp_thumbnail;
			HDC maindc,dc_thumbnail,dc_image;
			POINT pt;

			// check for operating system: Windows 9x does NOT support the HALFTONE stretchblt mode!
			vx.dwOSVersionInfoSize=sizeof(vx);
			GetVersionEx(&vx);
			is_nt=vx.dwPlatformId==VER_PLATFORM_WIN32_NT;

			
			bmp_image=LoadBitmap((HINSTANCE)hinst,"BITMAP1");
			if (bmp_image && GetObject(bmp_image,sizeof(bmpobj),&bmpobj)) {
				bigx=bmpobj.bmWidth;
				bigy=bmpobj.bmHeight;
				// do we need to stretch?
				if ((bigx>=width || bigy>=height) && (bigx>0 && bigy>0)) {
					stretchy=MulDiv(width,bigy,bigx);
					if (stretchy<=height) {
						w=width;
						h=stretchy;
						if (h<1) h=1;
					} else {
						stretchx=MulDiv(height,bigx,bigy);
						w=stretchx;
						if (w<1) w=1;
						h=height;
					}

					maindc=GetDC(GetDesktopWindow());
					dc_thumbnail=CreateCompatibleDC(maindc);
					dc_image=CreateCompatibleDC(maindc);
					bmp_thumbnail=CreateCompatibleBitmap(maindc,w,h);
					ReleaseDC(GetDesktopWindow(),maindc);
					oldbmp_image=(HBITMAP)SelectObject(dc_image,bmp_image);
					oldbmp_thumbnail=(HBITMAP)SelectObject(dc_thumbnail,bmp_thumbnail);
					if(is_nt) {
						SetStretchBltMode(dc_thumbnail,HALFTONE);
						SetBrushOrgEx(dc_thumbnail,0,0,&pt);

					} else {
						SetStretchBltMode(dc_thumbnail,COLORONCOLOR);
					}
					StretchBlt(dc_thumbnail,0,0,w,h,dc_image,0,0,bigx,bigy,SRCCOPY);
					SelectObject(dc_image,oldbmp_image);
					SelectObject(dc_thumbnail,oldbmp_thumbnail);
					DeleteDC(dc_image);
					DeleteDC(dc_thumbnail);
					DeleteObject(bmp_image);
					*ReturnedBitmap=bmp_thumbnail;
					return FS_BITMAP_EXTRACTED;
				} else {
					*ReturnedBitmap=bmp_image;
					return FS_BITMAP_EXTRACTED;
				}
			}
			return FS_BITMAP_NONE;
		}
	} else {
		memmove(RemoteName,RemoteName+pluginrootlen,strlen(RemoteName+pluginrootlen)+1);
		return FS_BITMAP_EXTRACT_YOURSELF | FS_BITMAP_CACHE;
	}
}

int __stdcall FsGetPreviewBitmapW(WCHAR* RemoteName,int width,int height,HBITMAP* ReturnedBitmap)
{
	int start=-1;
	int end=-1;
	int digits=-1;
	if (GetFileNameRange(RemoteName,&start,&end,&digits)) {
		WCHAR SingleRemoteName[MAX_PATH+1];
		if (CreateNumberedFileName(SingleRemoteName,MAX_PATH,RemoteName,start,digits)) {
			return FsGetPreviewBitmapW(SingleRemoteName,width,height,ReturnedBitmap);
		}
		return FS_BITMAP_NONE;
	}
	if (wcslen(RemoteName)<=4) {
		if (wcscmp(RemoteName,L"\\..\\")==0)
			return FS_BITMAP_NONE;
		else {
			return FsGetPreviewBitmap("\\",width,height,ReturnedBitmap);
		}
	} else {
		memmove(RemoteName,RemoteName+pluginrootlen,2*wcslen(RemoteName+pluginrootlen)+2);
		return FS_BITMAP_EXTRACT_YOURSELF | FS_BITMAP_CACHE;
	}
}

void __stdcall FsSetDefaultParams(FsDefaultParamStruct* dps)
{
	strlcpy(inifilename,dps->DefaultIniName,MAX_PATH-1);
}

BOOL __stdcall FsLinksToLocalFiles()
{
	return true;
}

BOOL __stdcall FsGetLocalName(char* RemoteName,int maxlen)
{
	if (strlen(RemoteName)<pluginrootlen+2)
		return false;
	MoveMemory (RemoteName,RemoteName+pluginrootlen,strlen(RemoteName+pluginrootlen)+1);
	return true;
}

BOOL __stdcall FsGetLocalNameW(WCHAR* RemoteName,int maxlen)
{
	if (wcslen(RemoteName)<pluginrootlen+2)
		return false;
	int start=-1;
	int end=-1;
	int digits=-1;
	if (GetFileNameRange(RemoteName,&start,&end,&digits)) {
		WCHAR SingleRemoteName[MAX_PATH+1];
		if (CreateNumberedFileName(SingleRemoteName,MAX_PATH,RemoteName,start,digits)) {
			wcslcpy(RemoteName,SingleRemoteName+pluginrootlen,maxlen);
			return true;
		}
		return false;
	}
	MoveMemory(RemoteName,RemoteName+pluginrootlen,2*wcslen(RemoteName+pluginrootlen)+2);
	return true;
}

/**************************************************************************************/
/*********************** content plugin = custom columns part! ************************/
/**************************************************************************************/

#define fieldcount 5
char* fieldnames[fieldcount]={
	"file count","first","last","digits","base name"};

int fieldtypes[fieldcount]={
		ft_numeric_32,ft_numeric_32,ft_numeric_32,ft_numeric_32,ft_stringw};

char* fieldunits_and_multiplechoicestrings[fieldcount]={
		"","","","",""};

int fieldflags[fieldcount]={0,0,0,0,0};

int sortorders[fieldcount]={1,1,1,1,1};


int __stdcall FsContentGetSupportedField(int FieldIndex,char* FieldName,char* Units,int maxlen)
{
	if (FieldIndex<0 || FieldIndex>=fieldcount)
		return ft_nomorefields;
	strlcpy(FieldName,fieldnames[FieldIndex],maxlen-1);
	strlcpy(Units,fieldunits_and_multiplechoicestrings[FieldIndex],maxlen-1);
	return fieldtypes[FieldIndex];
}

int __stdcall FsContentGetValueT(BOOL unicode,WCHAR* FileName,int FieldIndex,int UnitIndex,void* FieldValue,int maxlen,int flags)
{
	WCHAR *p,*p2;

	if (wcslen(FileName+pluginrootlen)<=3)
		return ft_fileerror;

	if (flags & CONTENT_DELAYIFSLOW) {
		if (FieldIndex==4)
			return ft_delayed;
		if (FieldIndex==5)
			return ft_ondemand;
	}
	int start=-1;
	int end=-1;
	int digits=-1;
	if (GetFileNameRange(FileName,&start,&end,&digits)) {
		switch (FieldIndex) {
		case 0:  // "count"
			*(int*)FieldValue=end-start+1;
			break;
		case 1:  // "start"
			*(int*)FieldValue=start;
			break;
		case 2:  // "end"
			*(int*)FieldValue=end;
			break;
		case 3:
			*(int*)FieldValue=digits;
			break;
		case 4:
			p=wcsrchr(FileName,'\\');
			if (p)
				p++;
			else
				p=FileName;
			p2=wcsrchr(p,'<');
			if (p2)
				p2[0]=0;
			wcslcpy((WCHAR*)FieldValue,p,maxlen/2);
			break;
		default:
			return ft_nosuchfield;
		}
	} else {
		switch (FieldIndex) {
		case 0:  // "count"
			*(int*)FieldValue=1;
			break;
		case 1:  // "start"
			*(int*)FieldValue=0;
			break;
		case 2:  // "end"
			*(int*)FieldValue=0;
			break;
		case 3:
			*(int*)FieldValue=0;
			break;
		case 4:
			p=wcsrchr(FileName,'\\');
			if (p)
				p++;
			else
				p=FileName;
			p2=wcsrchr(p,'.');
			if (p2)
				p2[0]=0;
			wcslcpy((WCHAR*)FieldValue,p,maxlen/2);
			break;
		default:
			return ft_nosuchfield;
		}
	}
	return fieldtypes[FieldIndex];  // very important!
}

int __stdcall FsContentGetValueW(WCHAR* FileName,int FieldIndex,int UnitIndex,void* FieldValue,int maxlen,int flags)
{
	return FsContentGetValueT(true,FileName,FieldIndex,UnitIndex,FieldValue,maxlen,flags);
}

int __stdcall FsContentGetValue(char* FileName,int FieldIndex,int UnitIndex,void* FieldValue,int maxlen,int flags)
{
	WCHAR FileNameW[wdirtypemax];
	return FsContentGetValueT(false,awfilenamecopy(FileNameW,FileName),FieldIndex,UnitIndex,FieldValue,maxlen,flags);
}

int __stdcall FsContentGetSupportedFieldFlags(int FieldIndex)
{
	if (FieldIndex==-1)
		return contflags_substmask | contflags_edit;
	else if (FieldIndex<0 || FieldIndex>=fieldcount)
		return 0;
	else
		return fieldflags[FieldIndex];
}

int __stdcall FsContentGetDefaultSortOrder(int FieldIndex)
{
	if (FieldIndex<0 || FieldIndex>=fieldcount)
		return 1;
	else 
		return sortorders[FieldIndex];
}

void __stdcall FsContentPluginUnloading(void)
{
	// If you do something in a background thread, you may
	// wait in this function until the thread has finished
	// its work to prevent Total Commander from closing!
	// MessageBox(0,"fsplugin unloading!","Test",0);
}
